#include "loggable.h"

Loggable::Loggable(const std::shared_ptr<Logger>& logger):
    logger(logger)
{}

void Loggable::log(Logger::Severity severity, const std::string& message) const {
    logger->log(severity, message);
}

void Loggable::debug(const std::string& message) const {
    log(Logger::Severity::debug, message);
}

void Loggable::info(const std::string& message) const {
    log(Logger::Severity::info, message);
}

void Loggable::minor(const std::string& message) const {
    log(Logger::Severity::minor, message);
}

void Loggable::major(const std::string& message) const {
    log(Logger::Severity::major, message);
}

void Loggable::warn(const std::string& message) const {
    log(Logger::Severity::warning, message);
}

void Loggable::error(const std::string& message) const {
    log(Logger::Severity::error, message);
}

void Loggable::fatal(const std::string& message) const {
    log(Logger::Severity::fatal, message);
}
